#include <iostream>
#include <cmath>
using namespace std;

// array is always the original array
// from: the beginning index of the search space
// from: the ending index of the search space
bool binarySearch (int array[], int from, int to, int toSearch)
{
	// to display the search space
	cout << "The current search space is: "; 
	for (int i = from; i <= to; i++)
		cout << array[i] << " ";
	cout << endl;	
	
	int len = to - from + 1;
	
	if (len == 1) // so to == from
	{
		if (array[to] == toSearch)
			return true;
		else
			return false;
	}
	else
	{
		double median = 0;
		
		// find the median
		if (len % 2 == 0) // even number of elements
			median = (array[(from + to - 1) / 2] + array[(from + to + 1) / 2]) / static_cast<double>(2);
		else 
			median = array[(from + to) / 2];
			
		cout << "The current median is " << median << endl;
		
		// compare with the median
		if (toSearch == median)
			return true;
		else if (toSearch < median)
		{
			// continue searching in the first half
			if (len % 2 == 0)
				return binarySearch (array, from, (from + to - 1) / 2, toSearch);
			else
				return binarySearch (array, from, (from + to) / 2 - 1, toSearch);
		}
		else 
		{
			// continue searching in the second half
			if (len % 2 == 0)
				return binarySearch (array, (from + to + 1) / 2, to, toSearch);
			else 
				return binarySearch (array, (from + to) / 2 + 1, to, toSearch);
		}
	}
}

int main ()
{
	int array[10] = {2, 5, 9, 10, 13, 16, 19, 20, 28, 30};
	for (int i = 0; i < 10; i++)
		cout << array[i] << " ";
	cout << endl;
	
	int toSearch = 0;
	cin >> toSearch;
	
	cout << binarySearch (array, 0, 9, toSearch);
	
	return 0;
}
